extern "C" {
#include "mgraph.h"
}

/*
 * edge descriptor f =   00 | e | y     | x
 *                            2  YBITS   XBITS
 *
 * e is 0,1 or 2.  The edge is edge e out of vertex (x,y).
 */

/*
 * We use BGL's implementation of Johnson All Pairs Shortest Paths
 */

#define VMASK (YMASK|XMASK)
#define ESHIFT (YBITS|XBITS)

namespace boost {
  struct layout_graph_traversal_category : 
    public virtual incidence_graph_tag,
    public virtual edge_list_graph_tag
    public virtual vertex_list_graph_tag { };
  
  struct graph_traits<Layout> {
    /* Concept Graph: */
    typedef int vertex_descriptor; /* vertex number, -1 => none */
    typedef int edge_descriptor; /* see above */
    typedef undirected_tag directed_category;
    typedef disallow_parallel_ege edge_parallel_category;
    typedef layout_graph_traversal_category traversal_category;
    inline int null_vertex() { return -1; }
  }
  struct out_edge_iterator_policies {
    static void increment(int& f) { f += 1<<ESHIFT; }
    static void decrement(int& f) { f -= 1<<ESHIFT; }

    template <class Reference>
    static Reference dereference(type<Reference>, const int& f)
    { return const_cast<Reference>(f); }

    static bool equal(int x, int y) { return x == y; }
  }
  struct graph_traits<Layout> {
    /* Concept IncidenceGraph: */
    typedef iterator_adaptor<int, out_edge_iterator_policies,
      iterator<std::bidirectional_iterator_tag,int>
    > out_edge_iterator;
    
    inline int source(int f, const Layout& g) { return f&VMASK; }
    inline int target(int f, const Layout& g) { return EDGE_END2(f&VMASK, f>>ESHIFT); }
    inline std::pair<typename graph_traits<Layout>::out_edge_iterator,
                     typename graph_traits<Layout>::out_edge_iterator>
    out_edges(int v, const Layout& g) {
      return std::make_pair(VE_MIN(v), VE_MAX(v));
    }
  
    out_edge_iterator> {


    /* Concept VertexListGraph: */
    typedef counting_iterator<int> vertex_iterator;
    
}

void calculate_layout_energy(const Layout*) {
  
  FOR_VERTEX(v1) {
    boost::dijkstra_shortest_paths(g, v1, 0);
    
			    /* weight_map(). ? */
			    /* vertex_index_map(vimap). */

			    
			    predecessor_map().
			    distance_map()



